// PPAsyncHFSStoreStream.h
// Implements IAStoreStream for asynchronous access to a Macintosh HFS file.
// Written by Blake Ward, User Experience Research, Apple Labs, Apple Computer, Inc.

#pragma once
#include "HFSStoreStream.h"

class PPAsyncHFSStoreStream : public HFSStoreStream {
public:
				PPAsyncHFSStoreStream(short vRef, long dirId, const StringPtr fileName,
							   OSType creator = 'NtSc', OSType fileType = 'NInd');
				
				~PPAsyncHFSStoreStream();			   
				//PPAsyncHFSStoreStream(short vRef, long dirId, const StringPtr fileName,
				//			   OSType creator, OSType fileType, bool isOpen, bool isWritable, 
				//			   short fRefNum);

				// PPAsyncHFSStoreStream(PPAsyncHFSStoreStream& s) : HFSStoreStream(s){}

				virtual IAStoreStream*	Clone();
				void GetFSSpec(FSSpec *fileSpec);
				
protected:

							   
				PPAsyncHFSStoreStream(short vRef, long dirId, const StringPtr fileName,
							   OSType creator, OSType fileType, bool isOpen, bool isWritable, 
							   short fRefNum);

				void		Write(uint32 address, const byte* data, uint32 length);
				uint32		Read(uint32 address, byte* data,  uint32 length);

};




class IAStorage;

IAStorage* MakePPAsyncHFSStorage(short vRef, long dirId, const StringPtr name, OSType creator, OSType t);

